
Ruby - Bug #15758

Object.const_defined?(name) falsely returns true on classes that are not defined

04/08/2019 11:30 AM - dux (Dino Reic)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: 2.6.2, 2.7.0-dev Backport: 2.4: DONTNEED, 2.5: DONTNEED, 2.6:

DONE

Description

in short https://i.imgur.com/qvIIBuu.png

Object.const_defined?('Baz::Bar') -> true

yet Baz::Bar -> class not found!

test to run, all ok on ruby 2.6.0, bug in 2.6.2

class Foo

end

class Bar

end

class Baz

  class Foo

  end

end

###

def report klass

  name     = "Object.const_defined?('%s')" % klass

  exists   = Object.const_defined?(klass)

  instance = eval klass rescue nil

  check    = (exists && instance) || (!exists && !instance)? 'ok' : 'ERROR!'

  puts [

    name.ljust(35),

    exists.to_s.ljust(5),

    (instance ? instance.to_s : 'nil').ljust(8),

    check

  ].join(' -> ')

end

report 'Foo'

report 'Bar'

report 'Baz'

report 'Naat'

report 'Baz::Foo'

report 'Baz::Bar'

report 'Baz::Naat'

puts   '---'

report 'Baz::Foo::Bar::Baz::Foo' # true in 2.6.2 :)

 running produces output

Object.const_defined?('Foo')        -> true  -> Foo      -> ok

Object.const_defined?('Bar')        -> true  -> Bar      -> ok

Object.const_defined?('Baz')        -> true  -> Baz      -> ok

Object.const_defined?('Naat')       -> false -> nil      -> ok

06/21/2025 1/3

https://i.imgur.com/qvIIBuu.png


Object.const_defined?('Baz::Foo')   -> true  -> Baz::Foo -> ok

Object.const_defined?('Baz::Bar')   -> true  -> nil      -> ERROR!

Object.const_defined?('Baz::Naat')  -> false -> nil      -> ok

---

Object.const_defined?('Baz::Foo::Bar::Baz::Foo') -> true  -> nil      -> ERROR!

Related issues:

Has duplicate Ruby - Bug #15875: const_defined? behavior inconsistency in 2.6... Closed

Associated revisions

Revision d10451f3fd51f577e704db770de48d05044eb45c - 04/08/2019 01:47 PM - nobu (Nobuyoshi Nakada)

object.c: fix searching nested const paths

object.c (rb_mod_const_get, rb_mod_const_defined): nested const

paths should not search from toplevel constants.

[ruby-core:92202] [Bug #15758]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@67472 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d10451f3fd51f577e704db770de48d05044eb45c - 04/08/2019 01:47 PM - nobu (Nobuyoshi Nakada)

object.c: fix searching nested const paths

object.c (rb_mod_const_get, rb_mod_const_defined): nested const

paths should not search from toplevel constants.

[ruby-core:92202] [Bug #15758]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@67472 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d10451f3 - 04/08/2019 01:47 PM - nobu (Nobuyoshi Nakada)

object.c: fix searching nested const paths

object.c (rb_mod_const_get, rb_mod_const_defined): nested const

paths should not search from toplevel constants.

[ruby-core:92202] [Bug #15758]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@67472 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 15eba4ed0ebb4e019a037b0af10b34fdbc85e03a - 12/09/2019 12:06 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) e1b592b508c72a56ae012869d97fe1580ff87246,d10451f3fd51f577e704db770de48d05044eb45c: [Backport #15758]

    test_module.rb: fix a typo

    * test/ruby/test_module.rb (TestModule#test_nested_get): fix a

      typo.  nested module's name is a qualified path.

    git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@67471 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

    object.c: fix searching nested const paths

    * object.c (rb_mod_const_get, rb_mod_const_defined): nested const

      paths should not search from toplevel constants.

      [ruby-core:92202] [Bug #15758]

    git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@67472 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_6@67830 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 15eba4ed0ebb4e019a037b0af10b34fdbc85e03a - 12/09/2019 12:06 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) e1b592b508c72a56ae012869d97fe1580ff87246,d10451f3fd51f577e704db770de48d05044eb45c: [Backport #15758]

    test_module.rb: fix a typo

    * test/ruby/test_module.rb (TestModule#test_nested_get): fix a

      typo.  nested module's name is a qualified path.

    git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@67471 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

    object.c: fix searching nested const paths
    * object.c (rb_mod_const_get, rb_mod_const_defined): nested const

      paths should not search from toplevel constants.

      [ruby-core:92202] [Bug #15758]

    git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@67472 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_6@67830 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 15eba4ed - 12/09/2019 12:06 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) e1b592b508c72a56ae012869d97fe1580ff87246,d10451f3fd51f577e704db770de48d05044eb45c: [Backport #15758]

    test_module.rb: fix a typo

    * test/ruby/test_module.rb (TestModule#test_nested_get): fix a

      typo.  nested module's name is a qualified path.

    git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@67471 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

    object.c: fix searching nested const paths

    * object.c (rb_mod_const_get, rb_mod_const_defined): nested const

      paths should not search from toplevel constants.

      [ruby-core:92202] [Bug #15758]

    git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@67472 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_6@67830 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 04/08/2019 11:43 AM - dux (Dino Reic)

- Description updated

#2 - 04/08/2019 01:45 PM - dux (Dino Reic)

- ruby -v changed from 2.6.2 to 2.6.2, 2.7.0-dev

#3 - 04/08/2019 01:46 PM - dux (Dino Reic)

- Description updated

#4 - 04/08/2019 01:47 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset trunk|r67472.

object.c: fix searching nested const paths

object.c (rb_mod_const_get, rb_mod_const_defined): nested const

paths should not search from toplevel constants.

[ruby-core:92202] [Bug #15758]

#5 - 05/25/2019 04:50 AM - nobu (Nobuyoshi Nakada)

- Has duplicate Bug #15875: const_defined? behavior inconsistency in 2.6.x series added

#6 - 05/25/2019 04:50 AM - nobu (Nobuyoshi Nakada)

- Backport changed from 2.4: UNKNOWN, 2.5: UNKNOWN, 2.6: UNKNOWN to 2.4: DONTNEED, 2.5: DONTNEED, 2.6: REQUIRED

#7 - 12/09/2019 12:06 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.4: DONTNEED, 2.5: DONTNEED, 2.6: REQUIRED to 2.4: DONTNEED, 2.5: DONTNEED, 2.6: DONE

ruby_2_6 r67830 merged revision(s) e1b592b508c72a56ae012869d97fe1580ff87246,d10451f3fd51f577e704db770de48d05044eb45c.
